#==========================================================================#
#  B.Forum Ver.1.00                                                      #
#  ⥸塼                                                          #
#  Encode = EUC                                                          #
#  Hiroaki,Sakuma( sakuma@beetas.org )                                   #
#  BEETAS.org( info@beetas.org )                                         #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2001-2002 BEETAS.org All Rights Reserved.                      #
#                                                                          #
#==========================================================================#
$version = '1.00-7';
$revision = '0.99.0050';
$rcfile = '.bforumrc';
#$rcfile = 'bforum.conf';

package Bforum;

# pl2pm.
require 5.005;
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(main init create about thread view tree list search form regist sendmail code plugin limit change browser setting decode error);
@EXPORT_OK = qw(index do print);
# //

#use strict ('refs','subs');
#use lib '.';

sub main {

	&init;

	if (&plugin('main',@_)) { exit; }

	if (defined $in{'search'}) {
		&search;
	} elsif ($in{'t'}) {
		$num = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
		if ($in{'v'}) {
			if ($in{'v'} eq 'list') {
				&list;
			} elsif ($in{'v'} eq 'tree') {
				&tree;
			} else {
				if ($in{'f'} eq 'f') {
					&form;
				} elsif ($in{'f'} eq 'r') {
					&regist;
				} else {
					&view;
				}
			}
		} else {
			if ($in{'f'} eq 'f') {
				&form;
			} elsif ($in{'f'} eq 'r') {
				&regist;
			} else {
				&thread;
			}
		}
	} else {
		if ($in{'f'} eq 'f') {
			&form;
		} elsif ($in{'f'} eq 'r') {
			&regist;
		} else {
			&index($in{'i'});
		}
	}
	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.head$browser","$SET{'USER_DIR'}/BF.head$browser");
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.foot$browser","$SET{'USER_DIR'}/BF.foot$browser");
	&print;
	undef @_;

}

sub init {

	$time{'start'} = (times)[0];

	$cgi = $main::cgi;
	$cgi ||= $ENV{'SCRIPT_NAME'};

	&decode;
	&setting("./$main::rcfile","$ENV{'HOME'}/$main::rcfile");
	&setting("$SET{'USER_DIR'}/$in{'id'}/$main::rcfile");

	&browser;

	if ($SET{'NKF'} || $SET{'JCODE'}) {
		if ($code[1] || $in{'f'} eq 'r' || $in{'f'} eq 'f') {
			if ($SET{'NKF'}) { eval("use $SET{'NKF'}"); }
			elsif ($SET{'JCODE'}) { require $SET{'JCODE'}; }
			$codeinit = 1;
			if (%in) {
				foreach (keys %in) { &code(\$in{$_},'euc'); }
			}
		}
	}

	if (!$SET{'USER_DIR'}) { &error(__LINE__ . '@' . __FILE__); }

}

sub create {

	if (&plugin('create',@_)) { return; }

	if (-d "$SET{'USER_DIR'}/$in{'id'}" && -z "$SET{'USER_DIR'}/$in{'id'}/index") {
		&_analysis('create',&_open(undef,"$SET{'USER_DIR'}/default/thread/1")) || &error(__LINE__ . '@' . __FILE__);
		$time = time;
		$create{'message'} =~ s/\n<br>\n/\n/gi;
		chomp ($create{'message'});
		$create{'new'} = "Author: $create{'author'}\n";
		$create{'new'} .= "Email: $create{'email'}\n";
		$create{'new'} .= "Title: $create{'title'}\n";
		$create{'new'} .= "No: 1\n";
		$create{'new'} .= "Host: System\n";
		$create{'new'} .= "Agent: System\n";
		$create{'new'} .= "Date: $time\n\n";
		$create{'new'} .= $create{'message'};

		mkdir ("$SET{'USER_DIR'}/$in{'id'}/$time",0777) || &error(__LINE__ . '@' . __FILE__);

		open (LOG,">$SET{'USER_DIR'}/$in{'id'}/$time/1") || &error(__LINE__ . '@' . __FILE__);
		binmode (LOG);
		print LOG $create{'new'};
		close (LOG);

		$cindex = "$time\n";
		open (INDEX,">$SET{'USER_DIR'}/$in{'id'}/index") || &error(__LINE__ . '@' . __FILE__);
		binmode (INDEX);
		print INDEX $cindex;
		close (INDEX);

	} else {

		&about(__LINE__ . '@' . __FILE__);

	}
}

sub about {

		$print .= &_open(undef,"$SET{'USER_DIR'}/BF.about$browser");
		$head = "<!-- Called by $_[0] -->\n" . &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.head$browser","$SET{'USER_DIR'}/BF.head$browser");
		$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.foot$browser","$SET{'USER_DIR'}/BF.foot$browser");
		&print;

}

sub index {

	local ($head) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index.head$browser","$SET{'USER_DIR'}/BF.index.head$browser");
	local ($foot) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index.foot$browser","$SET{'USER_DIR'}/BF.index.foot$browser");
	$index = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.index$browser","$SET{'USER_DIR'}/BF.index$browser");

	if (&plugin('index',@_)) { return; }

	my ($tmp1,$tmp3,$tmp4,$tmp5);
	my (@tmp6);
	if (-z "$SET{'USER_DIR'}/$in{'id'}/index") { &create; }
	open (INDEX,"$SET{'USER_DIR'}/$in{'id'}/index") || &create;
	if ($cindex) {
		@tmp6 = ($cindex);
	} else {
		binmode (INDEX);
		@tmp6 = <INDEX>;
		close (INDEX);
	}

	if (defined $in{'s'} && $in{'s'} <= 1) { &about(__LINE__ . '@' . __FILE__); }
	$in{'s'} ||= 1;
	$tmp1 = 0;
	while (1) {

		$in{'t'} = $tmp6[$tmp1];

		chomp($in{'t'});
		if (!$in{'t'}) { last; }

		if ($in{'t'} =~ /^#/ || !-d "$SET{'USER_DIR'}/$in{'id'}/$in{'t'}") {
			splice (@tmp6,$tmp1,1);
			next;
		}


		$tmp1 ++;

		my ($tmp2);

		$num = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
		$tmp5 = $num + 1;
		$tmp3 += $tmp5;

		$SET{'INDEX_NUMBER'} ||= 20;
		if ($tmp1 > (($in{'s'} - 1) * $SET{'INDEX_NUMBER'}) && $tmp1 <= ($in{'s'} * $SET{'INDEX_NUMBER'})) {

			undef %index;

			$index{'number'} = $tmp5;
			(undef,$index{'thread'},$index{'author'},undef,$index{'date:thread'},undef) = &_analysis(undef,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1"));
			(undef,undef,undef,undef,$index{'date:last'},undef) = &_analysis(undef,&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$index{'number'}"));

			&_analysis('index',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1"));

			if ($date < $index{'date:last'}) { $date = $index{'date:last'}; };

			$index{'new'} = "";
			if ($index{'date:last'} + $SET{'NEW_TIME'} > time) {
				$index{'new'} = $SET{'NEW_ELEM'};
			}
			$index{'date:thread'} = &_time($index{'date:thread'});
			$index{'date:last'} = &_time($index{'date:last'});
			$index{'thread'} = &_link("id=$in{'id'}&t=$in{'t'}",$index{'thread'});
			$tmp2 = $index;
			$tmp2 = &do($tmp2);
			$tmp2 = &change($tmp2,'index');
			$tmp4 .= $tmp2;

		}

	}

	if ((($in{'s'} - 1) * $SET{'INDEX_NUMBER'}) >= (@tmp6)) { &about(__LINE__ . '@' . __FILE__); }

	if ($in{'s'} < 2) {
		$SET{'DISP_INDEX_BACK_NL'} ||= $SET{'DISP_INDEX_BACK'};
		$foot =~ s/{back}/$SET{'DISP_INDEX_BACK_NL'}/g;
	} else {
		if ($in{'s'} == '2') {
			$foot =~ s/{back}/&_link($in{'id'},$SET{'DISP_INDEX_BACK'})/ge;
		} else {
			$foot =~ s/{back}/&_link("id=$in{'id'}&s=" . ($in{'s'} - 1),$SET{'DISP_INDEX_BACK'})/ge;
		}
	}
	if (($in{'s'} * $SET{'INDEX_NUMBER'}) >= (@tmp6)) {
		$SET{'DISP_INDEX_NEXT_NL'} ||= $SET{'DISP_INDEX_NEXT'};
		$foot =~ s/{next}/$SET{'DISP_INDEX_NEXT_NL'}/g;
	} else {
		$foot =~ s/{next}/&_link("id=$in{'id'}&s=" . ($in{'s'} + 1),$SET{'DISP_INDEX_NEXT'})/ge;
	}


	&_hyperlink($head,'{url:thread}',"$cgi?id=$in{'id'}&i=thread");
	&_hyperlink($head,'{url:number}',"$cgi?id=$in{'id'}&i=number");
	&_hyperlink($head,'{url:no}',"$cgi?id=$in{'id'}&i=no");
	&_hyperlink($head,'{url:last}',"$cgi?$in{'id'}");
	&_hyperlink($head,'{url:see}',"$cgi?id=$in{'id'}&i=see");

	$tmp2 = $head . $tmp4 . $foot;
	&_transpose($tmp2);
	$print .= $tmp2;
	if ($date) { $date = &_time($date); }
	$thread = @tmp6;
	$log = $tmp3;
}

sub _transpose {
	$_[0] =~ s/{new_thread:url}/$cgi?id=$in{'id'}&f=f/g;
	$_[0] =~ s/{res:url}/$cgi?id=$in{'id'}&t=$in{'t'}&v=$in{'v'}&f=f/g;
	$_[0] =~ s/{edit:url}/$cgi?id=$in{'id'}&t=$in{'t'}&f=f/g;
	$_[0] =~ s/{old:url}/$cgi?id=$in{'id'}&t=$in{'t'}&v=1/g;
	$_[0] =~ s/{new:url}/$cgi?id=$in{'id'}&t=$in{'t'}&v=$view{'number'}/g;
	$_[0] =~ s/{list:url}/$cgi?id=$in{'id'}&t=$in{'t'}&v=list&s=$in{'s'}/g;
	$_[0] =~ s/{tree:url}/$cgi?id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}/g;
	$_[0] =~ s/{top:url}/$cgi?$in{'id'}/g;

	$_[0] =~ s/{new_thread}/<a href="$cgi?id=$in{'id'}&f=f">$SET{'DISP_NEW_THREAD'}<\/a>/g;
	$_[0] =~ s/{res}/&_link("id=$in{'id'}&t=$in{'t'}&v=$in{'v'}&f=f",$SET{'DISP_RES'})/ge;
	$_[0] =~ s/{edit}/&_link("id=$in{'id'}&t=$in{'t'}&f=f",$SET{'DISP_EDIT'})/ge;
	$_[0] =~ s/{first}/&_link("id=$in{'id'}&t=$in{'t'}&v=1",$SET{'DISP_FIRST'})/ge;
	$_[0] =~ s/{last}/&_link("id=$in{'id'}&t=$in{'t'}&v=$view{'number'}",$SET{'DISP_LAST'})/ge;
	$_[0] =~ s/{list}/&_link("id=$in{'id'}&t=$in{'t'}&v=list&s=$in{'s'}",$SET{'DISP_LIST'})/ge;
	$_[0] =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}",$SET{'DISP_TREE'})/ge;
	$_[0] =~ s/{top}/&_link("$in{'id'}",$SET{'DISP_TOP'})/ge;
}

sub thread {

	if (&plugin('thread',@_)) { return; }

	$in{'v'} = 1;
	&view;
	&list;
}

sub view {
	$view = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.view$browser","$SET{'USER_DIR'}/BF.view$browser");

	if (&plugin('view',@_)) { return; }

	my ($tmp1,$tmp2);

	if (!&_indexcheck) { &about(__LINE__ . '@' . __FILE__); }

	&_analysis('view',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'v'}"));

	if (!$view{'no'}) { &about(__LINE__ . '@' . __FILE__); }

	$view{'number'} = $num + 1;

	$view{'new'} = "";
	if ($view{'date'} + $SET{'NEW_TIME'} > time) {
		$view{'new'} = $SET{'NEW_ELEM'};
	}
	$view{'date'} = &_time($view{'date'});

	if ($view{'delete'} || !&_listcheck($in{'v'})) {
		$view{'title'} = '()' . $view{'title'};
		&_analysis('view',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser","$SET{'USER_DIR'}/BF.delete$browser"));
		$view{'email'} = $SET{'ADDRESS'};
	}

	foreach (split(/,/,$SET{'PTAG'})) {
		$view{'message'} =~ s/&lt;$_(.*?)&gt;(.*?)&lt;\/$_&gt;/&_tag('p')/gies;
	}

	foreach (split(/,/,$SET{'ATAG'})) {
		$view{'message'} =~ s/&lt;$_(.*?)&gt;/&_tag('a')/gie;
	}

	&_autolink($view{'message'});

	$view{'message'} =~ s/(^|\n)(&gt;[(&gt;)(\s*)]+)(.*?)\n/$1<span style="color:#990000">$2$3<\/span>\n/g;
	$view{'message'} =~ s/(^|\n)(#[#(\s*)]+)(.*?)\n/$1<span style="color:#009900">$2$3<\/span>\n/g;


	if ($in{'v'} eq '1') {
		$st = 1;
		$in{'s'} ||= 1;
	} else {
		$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
		foreach (0 .. $tmp1) {
			if ($in{'v'} eq (split(/<0>/,&_open($_,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0]) {
				$st = int($_ / 20) + 1;
				last;
			}
		}
	}

	$sl = int(($in{'v'} - 1) / 20) + 1;

	$tmp2 = $view;

	if ($in{'v'} <= 1) {
		$SET{'DISP_BACK_NL'} ||= $SET{'DISP_BACK'};
		$tmp2 =~ s/{back}/$SET{'DISP_BACK_NL'}/g;
	} else {
		$v = $in{'v'} - 1;
		$tmp2 =~ s/{back}/&_link("id=$in{'id'}&t=$in{'t'}&v=$v",$SET{'DISP_BACK'})/ge;
	}

	if ($in{'v'} >= $view{'number'}) {
		$SET{'DISP_NEXT_NL'} ||= $SET{'DISP_NEXT'};
		$tmp2 =~ s/{next}/$SET{'DISP_NEXT_NL'}/g;
	} else {
		$v = $in{'v'} + 1;
		$tmp2 =~ s/{next}/&_link("id=$in{'id'}&t=$in{'t'}&v=$v",$SET{'DISP_NEXT'})/ge;
	}

	if (!$_[0]) {
		$tmp2 =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$st",$SET{'DISP_TREE'})/ge;
	} else {
		$SET{'DISP_TREE_NL'} ||= $SET{'DISP_TREE'};
		$tmp2 =~ s/{tree}/$SET{'DISP_TREE_NL'}/g;
	}

	$tmp2 =~ s/{list:url}/id=$in{'id'}&t=$in{'t'}&v=list&s=$sl/g;
	$tmp2 =~ s/{tree:url}/id=$in{'id'}&t=$in{'t'}&v=tree&s=$st/g;
	$tmp2 =~ s/{list}/&_link("id=$in{'id'}&t=$in{'t'}&v=list&s=$sl",$SET{'DISP_LIST'})/ge;
	$tmp2 =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$st",$SET{'DISP_TREE'})/ge;
	&_transpose($tmp2);
	$tmp2 = &do($tmp2);
	$tmp2 = &change($tmp2,'view');

	$print .= $tmp2;

}

sub tree {
	local ($head) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree.head$browser","$SET{'USER_DIR'}/BF.tree.head$browser");
	local ($foot) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree.foot$browser","$SET{'USER_DIR'}/BF.tree.foot$browser");
	$tree = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.tree$browser","$SET{'USER_DIR'}/BF.tree$browser");

	if (&plugin('tree',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	if (!&_indexcheck) { &about(__LINE__ . '@' . __FILE__); }

	$in{'v'} = 1;
	&view(1);

	if ($in{'s'} < 1) { &about(__LINE__ . '@' . __FILE__); }
	$in{'s'} ||= 1;
	$SET{'TREE_NUMBER'} ||= 20;
	$tmp1 = &_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");
	$tmp2 = $tmp1 - ($in{'s'} - 1) * $SET{'TREE_NUMBER'};
	foreach (reverse(1 .. $SET{'TREE_NUMBER'})) {

		$tree{'number'} = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[0];
		if (0 > ($tmp2 - $_)) { last; }

		&_analysis('tree',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$tree{'number'}"));

		$stage[$tree{'number'}] = (split(/<0>/,&_open(($tmp2 - $_),"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))[1];

		$tree{'new'} = "";
		if ($tree{'date'} + $SET{'NEW_TIME'} > time) {
			$tree{'new'} = $SET{'NEW_ELEM'};
		}
		$tree{'date'} = &_time($tree{'date'});
		if ($tree{'delete'}) {
			$tree{'title'} = '()' . $tree{'title'};
			&_analysis('tree',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser","$SET{'USER_DIR'}/BF.delete$browser"));
			$tree{'email'} = $SET{'ADDRESS'};
		}
		$tree{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$tree{'no'}",$tree{'title'});

		$tmp3 = ('<dl>' x $stage[$tree{'number'}]) . $tree . ('</dl>' x $stage[$tree{'number'}]);
		$tmp3 = &do($tmp3);
		$tmp3 = &change($tmp3,'tree');
		$tmp4 .= $tmp3;

	}

	if ((($in{'s'} - 1) * $SET{'TREE_NUMBER'}) >= $tmp1) { &about(__LINE__ . '@' . __FILE__); }

	if ($in{'s'} < 2) {
		$SET{'DISP_TREE_BACK_NL'} ||= $SET{'DISP_TREE_BACK'};
		$foot =~ s/{back}/$SET{'DISP_TREE_BACK_NL'}/g;
	} else {
		if ($in{'s'} == 1) {
			$foot =~ s/{back}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree",$SET{'DISP_TREE_BACK'})/ge;
		} else {
			$foot =~ s/{back}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=" . ($in{'s'} - 1),$SET{'DISP_TREE_BACK'})/ge;
		}
	}
	if (($in{'s'} * $SET{'TREE_NUMBER'}) >= $tmp1) {
		$SET{'DISP_TREE_NEXT_NL'} ||= $SET{'DISP_TREE_NEXT'};
		$foot =~ s/{next}/$SET{'DISP_TREE_NEXT_NL'}/g;
	} else {
		$foot =~ s/{next}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=" . ($in{'s'} + 1),$SET{'DISP_TREE_NEXT'})/ge;
	}

	$tmp5 = $head . $tmp4 . $foot;
	$tmp5 =~ s/{list}/&_link("id=$in{'id'}&t=$in{'t'}&v=list",$SET{'DISP_LIST'})/ge;
	$SET{'DISP_TREE_NL'} ||= $SET{'DISP_TREE'};
	$tmp5 =~ s/{tree}/$SET{'DISP_TREE_NL'}/g;

	&_transpose($tmp5);
	$print .= $tmp5;
}

sub list {
	local ($head) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list.head$browser","$SET{'USER_DIR'}/BF.list.head$browser");
	local ($foot) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list.foot$browser","$SET{'USER_DIR'}/BF.list.foot$browser");
	$list = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.list$browser","$SET{'USER_DIR'}/BF.list$browser");

	if (&plugin('list',@_)) { return; }

	my ($tmp1,$tmp2,$tmp3);

	if (!&_indexcheck) { &about(__LINE__ . '@' . __FILE__); }

	if ($in{'s'} < 1) { &about(__LINE__ . '@' . __FILE__); }
	$in{'s'} ||= 1;
	$SET{'LIST_NUMBER'} ||= 20;
	foreach (reverse ((($in{'s'} - 1) * $SET{'LIST_NUMBER'} + 1) .. ($in{'s'} * $SET{'LIST_NUMBER'}))) {
		if (&_analysis('list',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$_"))) {

			if ($date < $line{'date'}) { $date = $line{'date'}; };

			$list{'new'} = "";
			if ($list{'date'} + $SET{'NEW_TIME'} > time) {
				$list{'new'} = $SET{'NEW_ELEM'};
			}
			$list{'date'} = &_time($list{'date'});
			if ($list{'delete'} || !&_listcheck($_)) {
				$list{'title'} = '()' . $list{'title'};
				&_analysis('list',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.delete$browser","$SET{'USER_DIR'}/BF.delete$browser"));
				$list{'email'} = $SET{'ADDRESS'};
			}
			$list{'title'} = &_link("id=$in{'id'}&t=$in{'t'}&v=$list{'no'}",$list{'title'});

			$tmp1 = $list;
			$tmp1 = &do($tmp1);
			$tmp1 = &change($tmp1,'list');

			$tmp2 .= $tmp1;

		}
	}

	if ((($in{'s'} - 1) * $SET{'LIST_NUMBER'}) > (&_open('line',"$SET{'USER_DIR'}/$in{'t'}/list") + 1)) { &about(__LINE__ . '@' . __FILE__); }

	if ($in{'s'} == 1) {
		$SET{'DISP_LIST_BACK_NL'} ||= $SET{'DISP_LIST_BACK'};
		$foot =~ s/{back}/$SET{'DISP_LIST_BACK_NL'}/g;
	} else {
		$foot =~ s/{back}/&_link("id=$in{'id'}&t=$in{'t'}&v=list&s=" . ($in{'s'} - 1),$SET{'DISP_LIST_BACK'})/ge;
	}
	if ($in{'s'} > int(&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") / $SET{'LIST_NUMBER'})) {
		$SET{'DISP_LIST_NEXT_NL'} ||= $SET{'DISP_LIST_NEXT'};
		$foot =~ s/{next}/$SET{'DISP_LIST_NEXT_NL'}/g;
	} else {
		$foot =~ s/{next}/&_link("id=$in{'id'}&t=$in{'t'}&v=list&s=" . ($in{'s'} + 1),$SET{'DISP_LIST_NEXT'})/ge;
	}

	$tmp3 = $head . $tmp2 . $foot;
	$SET{'DISP_LIST_NL'} ||= $SET{'DISP_LIST'};
	$tmp3 =~ s/{list}/$SET{'DISP_LIST_NL'}/g;
	&_transpose($tmp3);
	$tmp3 = &do($tmp3);
	$print .= $tmp3;
}

sub search {
	local ($head) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search.head$browser","$SET{'USER_DIR'}/BF.search.head$browser");
	local ($foot) = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search.foot$browser","$SET{'USER_DIR'}/BF.search.foot$browser");
	$search = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.search$browser","$SET{'USER_DIR'}/BF.search$browser");

	if (&plugin('search',@_)) { return; }

	my ($tmp1,$tmp2);

	if ($SET{'NAMAZU_INDEX'} && $SET{'NAMAZU'}) {

		foreach (split(/&/,$in{'target'})) {
			$tmp1 .= "+$_:\"$in{'search'}\" or ";
		}

		print "Location: $SET{'NAMAZU'}?query=$tmp1&whence=$in{'whence'}&idxname=$SET{'NAMAZU_INDEX'}&max=$in{'max'}&result=normal&sort=score\n\n";
		exit;

	} else {

		$tmp2 = &_open(2,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser","$SET{'USER_DIR'}/BF.error$browser");
		$tmp2 ||= "ˤбƤޤ";

	}

	$print .= $head . $tmp2 . $foot;

}

sub form {

	$form = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.form$browser","$SET{'USER_DIR'}/BF.form$browser");

	if (&plugin('form',@_)) { return; }

	my ($tmp1);

	if (&limit) {
		$form = &_open(3,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser","$SET{'USER_DIR'}/BF.error$browser");
		$form ||= "<b>ե뤬ͤĶ, 񤭹ߤǤޤ</b>";
	}

	$in{'f'} = 'r';

	&_get_cookie;

	$notice .= &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.notice$browser","$SET{'USER_DIR'}/BF.notice$browser");
	$notice =~ s/(.+?)\n/<li>$1\n/g;
	$notice = "\n<ul>\n" . $notice . "\n</ul>\n";

	$tmp1 = $form;
	$tmp1 =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)\n/<form $1action=$2$3$2$4>$5\n<input type=hidden name="id" value="$in{'id'}">\n<input type=hidden name="t" value="$in{'t'}">\n<input type=hidden name="v" value="$in{'v'}">\n<input type=hidden name="f" value="r">\n/i;

	if ($in{'v'}) { &view; }
	if ($in{'t'}) { $tmp1 =~ s/{tree}/&_link("id=$in{'id'}&t=$in{'t'}&v=tree&s=$in{'s'}",$SET{'DISP_TREE'})/ge; }
	&_transpose($tmp1);

	$print .= $tmp1;
}

sub regist {

	$regist = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.regist$browser","$SET{'USER_DIR'}/BF.regist$browser");

	if (&plugin('regist',@_)) { return; }

	if (&limit) {
		&form;
		undef @_;
		return;
	} else {

		my ($tmp1,$tmp2,$tmp3,$tmp4);
		my (@tmp5);


		foreach (split(/,/,$SET{'INDISPENSABLE'})) {
			if (!$in{$_} && !$in{('nk.' . $_)}) {
				$error{$_} = 1;
			} elsif ($_ eq 'email' && $in{'email'} !~ /(.+)@(.+).(.+)/) {
				$error{$_} = 1;
			} elsif ($_ eq 'nk.email' && $in{'nk.email'} !~ /(.+)@(.+).(.+)/) {
				$error{$_} = 1;
			}
		}
		if (%error) {
			$notice = &_open(0,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser","$SET{'USER_DIR'}/BF.error$browser");
			$notice ||= "<b>顼ΰٽ񤭹ޤǤ</b>\n";
			&form;
		} else {

			if ($in{'t'}) {
				&_analysis('check',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/last"));
			} else {
				&_analysis('check',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/" . (split(/<0>/,&_open('0',"$SET{'USER_DIR'}/$in{'id'}/index")))[1] . "/1"));
			}
			$check{'message'} =~ s/\n<br>\n/\n/gi;
			chomp ($check{'message'});
			if ($in{'author'} eq $check{'author'} && $in{'message'} eq $check{'message'}) {
				print "Location: $cgi?id=$in{'id'}&t=$in{'t'}&v=$check{'no'}\n\n";
				exit;
			}

			$host = $ENV{'REMOTE_HOST'};
			$addr = $ENV{'REMOTE_ADDR'};
			if ($host eq $addr || $host eq '') { $host = gethostbyaddr(pack("C4",split(/\./,$addr)),2); }
			if ($host eq '') { $host = $addr; }
			$time = time;

			foreach (sort keys %in) {
				$_ =~ s/^nk\.//gi;
				if ($_ eq 'f' || $_ eq 'id' || $_ eq 'message' || $_ eq 't' || $_ eq 'v') { next; }
				my ($tmp1);
				$tmp1 = lc ($_);
				$tmp1 = ucfirst ($tmp1);
				$log .= "$tmp1: $in{$_}\n";
			}

			if (!$in{'t'}) {
				$no = 1;
			} else {
				$no = $num + 2;
			}
			$log .= "No: $no\n";
			$log .= "Host: $host\n";
			$log .= "Agent: $ENV{'HTTP_USER_AGENT'}\n";
			$log .= "Version: $main::version(Revision:$main::revision)\n";
			$log .= "Date: $time\n";
			$log .= "Referer: $in{'v'}\n";
			$log .= "\n$in{'message'}\n";

			if(&_lock) {

				if (!$in{'t'}) {
					$in{'t'} = time;
					mkdir ("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}",0777) || &error(__LINE__ . '@' . __FILE__);

					foreach ($no,'last') {
						open (LOG,">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/1") || &error(__LINE__ . '@' . __FILE__);
						binmode (LOG);
						print LOG $log;
						close (LOG);
					}

				} else {

					foreach ($no,'last') {
						open (LOG,">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$_") || &error(__LINE__ . '@' . __FILE__);
						binmode (LOG);
						print LOG $log;
						close (LOG);
					}

					@list = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list",">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list");

					if ($in{'v'} && $in{'v'} ne '1') {
						$tmp1 = 0;
						$tmp2 = 0;
						foreach (@list) {
							$tmp2 ++;
							@tmp5 = split (/<0>/,$_);
							if ($tmp5[0] eq $in{'v'}) {
								$tmp5[1] ++;
								splice (@list,$tmp2,undef,"$no<0>$tmp5[1]<0>\n");
								last;
							}
						}
					} else {
						unshift (@list,"$no<0>0<0>\n");
					}

					open (LIST,">$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list.tmp") || &error(__LINE__ . '@' . __FILE__);
					binmode (LIST);
					print LIST @list;
					close (LIST);
					if (!((unlink ("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")) && (rename ("$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list.tmp","$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")))) { &error(__LINE__ . '@' . __FILE__); }

				}

				@index = &_open('file',"$SET{'USER_DIR'}/$in{'id'}/index");
				if (!@index) { &error(__LINE__ . '@' . __FILE__); }

				if ($SET{'INDEX_SORT'} =~ /^TOP$/i || !$SET{'INDEX_SORT'}) {
					$tmp3 = 0;
					foreach (@index) {
						$tmp4 = $_;
						chomp($tmp4);
						if ($tmp4 eq $in{'t'}) {
							splice (@index,$tmp3,1);
							last;
						}
						undef $tmp4;
						$tmp3 ++;
					}
					unshift (@index,"$in{'t'}\n");
				} elsif ($SET{'INDEX_SORT'} =~ /^NO$/i && $no eq '1') {
					unshift (@index,"$in{'t'}\n");
				}

				open (INDEX,">$SET{'USER_DIR'}/$in{'id'}/index") || &error(__LINE__ . '@' . __FILE__);
				binmode (INDEX);
				print INDEX @index;
				close(INDEX);


				&_unlock;

				&mknmz;
				$in{'url'} = $ENV{'HTTP_HOST'} . $cgi . "?id=$in{'id'}&t=$in{'t'}&v=$no";
				&sendmail(&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.email$browser","$SET{'USER_DIR'}/BF.email$browser"),\%in);

				$regist =~ s/(\\*)<%(.+?)(\\*)%>/&_do/segi;

				if ($browser eq '.wap') {
					&view;
				} else {
					print &_set_cookie;
					print "Content-type: text/html;\n\n";
					print "<html><head><meta http-equiv=\"refresh\" content=\"0;url=$cgi?id=$in{'id'}&t=$in{'t'}&v=$no\"></head></html>\n";
				}
			} else {
				&form;
				undef @_;
				return;
			}
			exit;
		}
	}
}

sub mknmz {

	if (&plugin('mknmz',@_)) { return; }

	if ($SET{'MKNMZ'}) {
		my ($tmp1);
		my (@tmp2);

		$SET{'MKNMZ'} =~ s/\\/\\\\/g;
		$tmp1 = "$cgi?id=$in{'id'}&t=$in{'t'}&v=$no";
		$tmp1 =~ s/\//\\\//g;
		$tmp1 =~ s/\&/\\&/g;
		@tmp2 = ($SET{'MKNMZ'},"--no-encode-uri","--no-delete","--media-type=text/bforum","--replace=\"s/.*/$tmp1/\"","$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$no");

		open (MKNMZ,"@tmp2 |");
		open (NMZLOG,">$SET{'USER_DIR'}/$in{'id'}/BF.mknmz.log");
		binmode (NMZLOG);
		print NMZLOG (<MKNMZ>);
		close (MKNMZ);
		close (NMZLOG);

		return;
	}
}

sub sendmail {

	if (&plugin('sendmail',@_)) { return; }

	if ($SET{'SENDMAIL'} && open (MAIL, "| $SET{'SENDMAIL'} -t")) {
		local ($tmp1);

		$tmp1 = $_[0];

		%email = %{$_[1]};
		$email{'address'} = $SET{'ADDRESS'};
		$email{'subject'} = $email{'title'};
		$email{'message'} =~ s/&lt;/</g;
		$email{'message'} =~ s/&gt;/>/g;
		$email{'message'} =~ s/&amp;/&/g;
		$email{'message'} =~ s/&quot;/"/g;
		$email{'separator'} = "\n" . ("-" x 76) . "\n";
		$email{'version'} = $main::version;
		$email{'revision'} = $main::revision;

		$tmp1 = &do($tmp1);
		$tmp1 = &change($tmp1,'email');

		$tmp1 =~ s/Subject: (.*)/&_subject($1)/ge;
		&code(\$tmp1,'jis');
		print MAIL $tmp1;
		close (MAIL);
	}
	undef @_;
}

sub _subject {
	my ($tmp1,$tmp3,$tmp4,$tmp5);
	local ($tmp2);
	$tmp1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	$tmp2 = $_[0];
	&code(\$tmp2,'jis');
	$tmp2 =~ s/\x1b\x28\x42/\x1b\x28\x4a/g;
	$tmp2 = unpack("B*", $tmp2);
	for ($tmp5 = 0; $tmp3 = substr($tmp2, $tmp5, 6); $tmp5 += 6) {
		$tmp4 .= substr($tmp1, ord(pack("B*", "00" . $tmp3)), 1);
		if (length($tmp3) == 2) {
			$tmp4 .= "==";
		} elsif (length($tmp3) == 4) {
			$tmp4 .= "=";
		}
	}
	chomp ($tmp4);
	return("Subject: =?iso-2022-jp?B?$tmp4?=");
}

sub code {

	if (&plugin('code',@_)) { return; }

	my ($tmp1,$tmp2);

	if ($codeinit) {

		($tmp1,$tmp2) = @_;

		if ($tmp1 =~ /\w/) {
			if ($SET{'NKF'}) {
				$$tmp1 = NKF::nkf("--$tmp2",$$tmp1);
			} elsif ($SET{'JCODE'}) {
				&jcode::convert($tmp1,$tmp2,undef,'z');
			}
		}

		undef @_;
	}
}

sub _form {

	my ($tmp1,$tmp2,$tmp3,$tmp4);

	$tmp1 = $1;
	$tmp2 = $2;
	$tmp3 = $4;
	$tmp4 = $5;

	$tmp4 =~ s/<select (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/select>/&_form_select/ges;
	$tmp4 =~ s/<input (.*?)name=(["']?)(.*?)\2(.*?)>/&_form_input/ges;
	$tmp4 =~ s/<textarea (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/textarea>/&_form_textarea/ges;

	return "<form " . $tmp1 . "action=" . $tmp2 . $cgi . $tmp2 . $tmp3 . ">" . $tmp4 . "</form>";

}

sub _form_input {
	local ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<input $1name=$2$3$2$4>";
	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;
	$tmp5 = $4;

	if (($tmp2 =~ /type=(["']?)text/ || $tmp5 =~ /type=(["']?)text/) || ($tmp2 !~ /type/ && $tmp5 !~ /type/)) {
		return &_form_text;
	} elsif ($tmp2 =~ /type=(["']?)submit/ || $tmp5 =~ /type=(["']?)submit/) {
		return $tmp1;
	} elsif ($tmp2 =~ /type=(["']?)hidden/ || $tmp5 =~ /type=(["']?)hidden/) {
		return &_form_hidden;
	} elsif ($tmp2 =~ /type=(["']?)checkbox/ || $tmp5 =~ /type=(["']?)checkbox/) {
		return &_form_checkbox;
	} elsif ($tmp2 =~ /type=(["']?)radio/ || $tmp5 =~ /type=(["']?)radio/) {
		return &_form_radio;
	} else {
		return $tmp1;
	}
}

sub _form_hidden {

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gi;
		$tmp1 =~ s/>/ value="$in{$tmp4}">/i;
	}

	undef @_;
	return $tmp1;
}

sub _form_checkbox {

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked//gi; }
	foreach (split(/&/,$in{$tmp4})) {
		if ($tmp1 =~ / value=(["']?)$_\1/gi) {
			$tmp1 =~ s/>/ checked>/i;
			last;
		}
	}

	undef @_;
	return $tmp1;
}

sub _form_radio {

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked//gi; }
	if ($tmp1 =~ / value=(["']?)$in{$tmp4}/gi) {
		$tmp1 =~ s/>/ checked>/i;
	}


	undef @_;
	return $tmp1;
}


sub _form_text {
	my ($tmp6);

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gi;
		$tmp1 =~ s/>/ value="$in{$tmp4}">/i;
	} elsif ($in{'v'} && $tmp4 eq 'title') {
		&_analysis('form',&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/$in{'v'}"));
		if ($form{'title'} =~ s/^Re\^(\d+): //) {
			$tmp6 = "Re^" . ($1 + 1) . ": $form{'title'}";
		} elsif ($form{'title'} =~ s/^Re: //) {
			$tmp6 = "Re^2: $form{'title'}";
		} else {
			$tmp6 = "Re: $form{'title'}";
		}
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gi;
		$tmp1 =~ s/>/ value="$tmp6">/i;
	}

	undef @_;
	return $tmp1;
}

sub _form_textarea {
	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<textarea $1name=$2$3$2$4>$in{$3}</textarea>";
	$tmp2 = $2;
	$tmp3 = $3;

	undef @_;
	return $tmp1;
}

sub _form_select {
	my ($tmp1,$tmp2);

	$tmp1 = "<select $1name=$2$3$2$4>$5</select>";
	$tmp2 = $3;

	if ($in{$tmp2}) {
		$tmp1 =~ s/ selected//gi;
		$tmp1 =~ s/<(option (.*)value=(["']?)$in{$tmp2}\3(.*))>/<$1 selected>/gi;
	}

	undef @_;
	return $tmp1;
}

sub _set_cookie {
	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4,@tmp5,@tmp6);
	@tmp4 = gmtime(time + 90 * 60 * 60 * 24);
	@tmp5 = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@tmp6 = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	$tmp1 = sprintf("%s, %02d\-%s\-%04d %02d\:%02d\:%02d GMT",$tmp5[$tmp4[6]],$tmp4[3],$tmp6[$tmp4[4]],$tmp4[5]+1900,$tmp4[2],$tmp4[1],$tmp4[0]);

	foreach (sort keys %in) {
		if ($_ eq 'f' || $_ eq 'id' || $_ eq 'title' || $_ eq 'message' || $_ eq 't' || $_ eq 'v') { next; }
		$tmp2 = $in{$_};
		$tmp2 =~ s/([\%\+\;\,\=\&\_\:])/'%' . unpack("H2",$1)/ge;
		$tmp3 .= "$_:$tmp2,";
	}
	undef @_;
	return "Set-Cookie: B.Forum:$in{'id'}=$tmp3; expires=$tmp1\n";
}

sub _get_cookie {
	local ($tmp1);
	my ($tmp2);
	local (@tmp3);
	foreach $tmp1 (split(/;\s*/,$ENV{'HTTP_COOKIE'})) {
		if ((split(/=/,$tmp1))[0] eq "B.Forum:$in{'id'}") {
			&code(\$tmp1,'euc');
			foreach $tmp2 (split(/,\s*/,(split(/=/,$tmp1))[1])) {
				@tmp3 = split(/:/,$tmp2);
				$tmp3[1] =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
				$in{$tmp3[0]} = $tmp3[1];
			}
			last;
		}
	}
}

sub _lock {
	my ($tmp1,$tmp2);
	if (open (LOCK,"$SET{'USER_DIR'}/$in{'id'}/lock")) {
		$tmp1 = <LOCK>;
		close (LOCK);
		chomp ($tmp1);
		$tmp2 = 0;
		foreach (1 .. 5) {
			if ((time - $tmp1) > 60) {
				$tmp2 = 1;
				last;
			} else {
				sleep (1);
			}
		}
	} else {
		$tmp2 = 1;
	}
	if ($tmp2) {
		open (LOCK,">$SET{'USER_DIR'}/$in{'id'}/lock");
		binmode (LOCK);
		print LOCK time;
		close(LOCK);
		return 1;
	} else {
		$notice = &_open(1,"$SET{'USER_DIR'}/$in{'id'}/BF.error$browser","$SET{'USER_DIR'}/BF.error$browser");
		$notice ||= "<b>ߤäƤޤ</b>\n";
		return undef;
	}
}

sub _unlock {
	unlink ("$SET{'USER_DIR'}/$in{'id'}/lock");
}

sub _analysis {
	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	my (@tmp6);
	($tmp1,$tmp2) = @_;
	($tmp2,@tmp6) = split(/\n\n/,$tmp2);
	foreach (split(/\n/,$tmp2)) {
		if ($_ =~ /^\s*(.+?):\s+(.*?)\s*$/) {
			$tmp4 = lc $1;
			$$tmp1{$tmp4} = $2;
		}
	}
	$tmp3 = join("\n\n",@tmp6);

	if ($$tmp1{'type'} ne 'text/html') {
		foreach (split(/\n/,$tmp3)) {
			if ($_ !~ '<' && $_ !~ '>') { $_ .= "\n<br>";  }
			$tmp5 .= $_ . "\n";
		}
	} else {
		$tmp5 = $tmp3;
	}

	if (!$$tmp1{'title'}) { $$tmp1{'title'} = "(̵)"; }

	if ($SET{'TITLE_LENGTH'}) {
		if (length $$tmp1{'title'} > $SET{'TITLE_LENGTH'}) {
			$$tmp1{'title'} = (substr $$tmp1{'title'},0,$SET{'TITLE_LENGTH'});
			if ($$tmp1{'title'} =~ /([\xa1-\xfe]+)$/) { if (length($1) % 2) { $$tmp1{'title'} = substr($$tmp1{'title'},0,($SET{'TITLE_LENGTH'} - 1)); } }
			$$tmp1{'title'} .= '...';
		}
	}

	$$tmp1{'message'} = $tmp5;
	undef @_;
	return ($$tmp1{'no'},$$tmp1{'title'},$$tmp1{'author'},$$tmp1{'email'},$$tmp1{'date'},$$tmp1{'message'});
}

sub _tag {
	my ($tmp1,$tmp2);
	$tmp1 = $1;
	$tmp2 = $2;
	$tmp1 =~ s/&quot;/"/g;
	$tmp1 =~ s/ href=(["']?)(.*)\1/ href=$1$2$1 target=_blank/g;
	$tmp1 =~ s/ on(click|dbclick|mouseover|mouseout|focus|unfocus)=(["']?)(.*)\2//gi;
	if ($_[0] eq 'p') {
		undef @_;
		return "<$_$tmp1>$tmp2<\/$_>";
	}
	if ($_[0] eq 'a') {
		undef @_;
		return "<$_$tmp1>";
	}
}

sub _hyperlink {
	$_[0] =~ s/<a([^>]+)$href=(["']?)$_[1]\2>(.+)<\/a>/<a$1$href=$2$_[2]$2>$3<\/a>/gi;
}

sub _link {
	my (@tmp) = @_;
	return ('<a ' . $href . '="' . $cgi . '?' . $tmp[0] . '">' . $tmp[1] . '</a>');
}

sub _autolink {
	$_[0] =~ s/([^=^\"^'^>]|^)(http\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)\.(gif|jpg|png)/$1<a href=\"$2\.$3\" target=_blank><img src=\"$2\.$3\" border=0><\/a>/g;
	$_[0] =~ s/([^=^\"^'^>]|^)(http\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+)/$1<a $href=\"$2\" target=_blank>$2<\/a>/g;
	$_[0] =~ s/([^=^\"^'^>]|^)([^\s]+)\@(.+)\.([a-zA-Z]+)/$1<a $href=\"mailto:$2\@$3\.$4\">$2\@$3\.$4<\/a>/g;
}

sub plugin {
	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	$tmp1 = shift @_;

	if ($SET{'PLUGIN_DIR'}) {
		$plugin = &_open(undef,"$SET{'PLUGIN_DIR'}/$tmp1.pl");
		if ($plugin) {
			open (NULL,undef);
			$tmp2 = select (NULL);
			$tmp3 = eval $plugin;
			if ($tmp3 && eval "${tmp1}::status();" && ((! eval "${tmp1}::require_max();" || (split(/\./,$main::revision))[-1] <= eval "${tmp1}::require_max();") && (! eval "${tmp1}::require_min();" || (split(/\./,$main::revision))[-1] >= eval "${tmp1}::require_min();"))) {
				$tmp4 = eval "${tmp1}::main(\$head,\$foot,\\\%in,\@_);";
				if (defined $tmp4) {
					$plugin{($SET{'PLUGIN_DIR'} . "/" . $tmp1 . ".pl")} = eval("${tmp1}::version();");
					$tmp5 = $tmp4;
				} else {
					undef $tmp5;
				}
			} else {
				undef $tmp5;
			}
			select ($tmp2);
			close (NULL);
			$print .= $tmp5 . $@;
			return $tmp5;
		} else {
			return undef;
		}
	} else {
		return undef;
	}
}

sub limit {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7);

	undef $tmp1;

	foreach ($SET{'LIMIT_THREAD'},$SET{'LIMIT_THREAD_ITEM'},$SET{'LIMIT_CAPACITY'},$SET{'LIMIT_ITEM'}) { $_ =~ tr/0-9//cd; }

	if ($SET{'LIMIT_THREAD'} || $SET{'LIMIT_THREAD_ITEM'} || $SET{'LIMIT_CAPACITY'} || $SET{'LIMIT_ITEM'}) {
		if (!$tmp1 && $SET{'LIMIT_THREAD'} && !$in{'t'}) {

			undef $tmp2;
			foreach $tmp3 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {

				chomp($tmp3);
				if ($tmp3 =~ /^#/) {
					next;
				} elsif (!-d "$SET{'USER_DIR'}/$in{'id'}/$tmp3") {
					next;
				} else {
					$tmp2 ++;
				}

			}

			if ($SET{'LIMIT_THREAD'} <= $tmp2) { $tmp1 = 1; }

		}
		if (!$tmp1 && $SET{'LIMIT_THREAD_ITEM'} && $in{'t'} && $SET{'LIMIT_THREAD_ITEM'} <= (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list") + 1)) {
			$tmp1 = 1;
		}
		if (!$tmp1 && $SET{'LIMIT_CAPACITY'} || $SET{'LIMIT_ITEM'}) {

			undef $tmp4;
			undef $tmp5;

			foreach $tmp6 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/index")) {
				chomp($tmp6);
				if ($tmp6 =~ /^#/) {
					next;
				} elsif (!-d "$SET{'USER_DIR'}/$in{'id'}/$tmp6") {
					next;
				} else {
					opendir (DIR,"$SET{'USER_DIR'}/$in{'id'}/$tmp6");
					foreach $tmp7 (readdir (DIR)) {
						if ($tmp7 eq '.' || $tmp7 eq '..') { next; }
						if ($tmp7 =~ /\d/) { $tmp5 ++; }
						if ($SET{'SECTORSIZE'}) {
							$tmp4 += ((int((-s "$SET{'USER_DIR'}/$in{'id'}/$tmp6/$tmp7")/$SET{'SECTORSIZE'})) + 1) * $SET{'SECTORSIZE'};
						} else {
							$tmp4 += (-s "$SET{'USER_DIR'}/$in{'id'}/$tmp6/$tmp7");
						}
					}
					closedir (DIR);

				}
			}
			if ($SET{'LIMIT_CAPACITY'} && $SET{'LIMIT_CAPACITY'} <= $tmp4) {
				$tmp1 = 1;
			} elsif ($SET{'LIMIT_ITEM'} && $SET{'LIMIT_ITEM'} <= $tmp5) {
				$tmp1 = 1;
			}

		}

	}

	return $tmp1;

}

sub _time {
	my (@tmp1);
	$ENV{'TZ'} = "JST-9";
	@tmp1 = localtime($_[0]);
	@tmp1 = ($tmp1[5] + 1900,'/',$tmp1[4] + 1,'/',$tmp1[3],$tmp1[2],$tmp1[1]);
	undef @_;
	return sprintf("%04d%s%02d%s%02d %02d:%02d",@tmp1);
}

sub _default {
	$thread ||= 0;
	$log ||= 0;
	$date ||= '0000/00/00';
	$id ||= $in{'id'};
	undef @_;
}

sub _replace {
	${$_[0]} =~ s/<\!-- $_[1] --> (.+?) <\!-- $_[1] -->/<\!-- $_[1] --> $_[2] <\!-- $_[1] -->/gs;
	undef @_;
}


sub _open {

	my ($tmp1,$tmp2,$tmp3);
	my (@tmp4,@tmp5);

	($tmp1,@tmp4) = @_;
	undef @_;

	foreach $tmp2 (@tmp4) {
		if (defined $chache{$tmp2}) {
			@tmp5 = split(/\n/,$chache{$tmp2});
			foreach (@tmp5) { $_ .= "\n"; }
			last;
		} elsif ($tmp2 =~ /^>/ || -f $tmp2) {
			open (FILE,$tmp2);
			binmode (FILE);
			@tmp5 = <FILE>;
			close (FILE);
			last;
		} else {
			next;
		}
	}

	if ($tmp1 eq 'line') {
		if (!@tmp5) {
			return 0;
		} else {
			return $tmp3 = @tmp5;
		}
	} elsif ($tmp1 eq 'file') {
		return @tmp5;
	} elsif (defined $tmp1) {
		$chache{$tmp2} = join('',@tmp5);
		return $tmp5[$tmp1];
	} else {
		$chache{$tmp2} = join('',@tmp5);
		return join('',@tmp5);
	}
}

sub do {

	my ($tmp1);

	$tmp1 = $_[0];
	$tmp1 =~ s/(\\*)<%(.+?)(\\*)%>/&_do/segi;

	undef @_;
	return $tmp1;
}

sub _do {
	my ($tmp1,$tmp2,$tmp3,$tmp4);
	local ($tmp5);
#	$print =~ s/(\\*)<%(.+?)(\\*)%>/&_do/geis;
	if (length($1) % 2) {
		$tmp1 = $1 . '<%' . $2 . $3 . '%>';
	} else {
		if (length($3) % 2) {
			$tmp1 = $1 . '<%' . $2 . $3 . '%>';
		} else {
			#
			$tmp2 = $1;
			$tmp3 = $2;
			$tmp4 = $3;
			$tmp3 =~ s/(\W)print(\W)/$1\$tmp5 .=$2/g;
			eval ($tmp3);
			$tmp1 = $tmp2 . $tmp5 . $tmp4;
		}
	}
	$tmp1 =~ s/\\\\/\\/gi;

	undef @_;
	return $tmp1;
}

sub change {

	my ($tmp1);

	$tmp1 = $_[0];
	$tmp1 =~ s/(\\*)(\w*){(.+?)}/&_change($_[1])/ge;

	undef @_;
	return $tmp1;
}

sub _change {
	my ($tmp1);
	if (length($1) % 2) {
		$tmp1 = $1 . $2 . '{' . $3 . '}';
	} else {
		if ($_[0]) {
			if (defined ${$_[0]}{$3}) {
				$tmp1 = $1 . $2 . ${$_[0]}{$3};
			} else {
				$tmp1 = $1 . $2 . '{' . $3 . '}';
			}
		} else {
			if ($$3) {
				$tmp1 = $1 . $2 . $$3;
			} elsif (defined $$3) {
				$tmp1 = $1 . $2;
			} elsif (defined ${$2}{$3}) {
				$tmp1 = $1 . ${$2}{$3};
			} else {
				$tmp1 = $1 . $2 . '{' . $3 . '}';
			}
		}
	}
	$tmp1 =~ s/\\\\/\\/gi;

	undef @_;
	return $tmp1;
}

sub _indexcheck {

	my ($tmp1,$tmp2);
	my (@tmp3);

	open (INDEX,"$SET{'USER_DIR'}/$in{'id'}/index");
	binmode (INDEX);
	@tmp3 = <INDEX>;
	close (INDEX);

	$tmp2 = 0;
	foreach $tmp1 (@tmp3) {

		chomp($tmp1);
		if ($tmp1 =~ /^#/) {
			next;
		} elsif (!-d "$SET{'USER_DIR'}/$in{'id'}/$tmp1") {
			next;
		}

		if ($tmp1 eq $in{'t'}) {
			$tmp2 = 1;
			last;
		}

	}

	undef @_;
	return $tmp2;

}

sub _listcheck {

	my ($tmp1,$tmp2);

	if ($_[0] eq '1') { return 1; }

	undef $tmp2;
	foreach $tmp1 (&_open('file',"$SET{'USER_DIR'}/$in{'id'}/$in{'t'}/list")) {

		chomp ($tmp1);
		if ($tmp1 =~ /^#/) { next; }

		if ((split(/<0>/,$tmp1))[0] eq $_[0]) {
			$tmp2 = 1;
			last;
		}

	}

	undef @_;
	return $tmp2;

}

sub browser {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8);

	open (BROWSER,"$SET{'USER_DIR'}/BF.browser");
	$tmp1 = join('',(<BROWSER>));
	close (BROWSER);

	$tmp2 = (split(/\//,$ENV{'HTTP_USER_AGENT'}))[0];

	$tmp1 =~ s/[^\\]#.*\n//g;

	$content = 'text/html';
	$browser = '';
	$href = 'href';
	@code = ('EUC-JP',undef);

	foreach $tmp3 ($tmp1 =~ /\n*([^\n]*?:[^:]*)\n/gs) {
		$tmp3 =~ s/\n//g;
		$tmp3 =~ /(.*):(.*)/;
		if ($tmp2 eq $1) {
			$tmp5 = $2;
			$tmp5 =~ s/[\n\s]//g;
			foreach $tmp6 ($tmp5 =~ /(.*?=.*?);/g) {
				$tmp6 =~ /(.*?)=(.*)/;
				$tmp7 = $1;
				$tmp8 = $2;
				if ($tmp8 =~ /,/) {
					@$tmp7 = split(/,/,$tmp8);
				} else {
					$$tmp7 = $tmp8;
				}
			}
			last;
		}
	}

}

sub setting {
	my ($tmp1);
	foreach (@_) {
		foreach $tmp1 (&_open('file',$_)) {
			if ($tmp1 =~ /^(\s*)#/) { next; }
			($tmp1) = split (/#(\s+)/,$tmp1);
			($tmp1) = split (/(\s+)#/,$tmp1);
			if (!$tmp1) { next; }
			if ($tmp1 =~ /\s*([^\s]+?)\s+(.*)\s*/gi) {
				$SET{uc($1)} = $2;
			} elsif ($tmp1 =~ /\s*([^\s]+?)\s*/gi) {
				$SET{uc($1)} = "";
			}
		}
	}
	undef @_;
	return undef;
}

sub decode {

	my ($tmp1,$tmp2,$tmp3,$tmp4);
	$tmp1 = $ENV{'REQUEST_METHOD'};
	$tmp2 = $ENV{'QUERY_STRING'};
	$tmp3 = $ENV{'CONTENT_LENGTH'};

	if ($tmp1 eq "POST") {
		read(STDIN, $tmp4, $tmp3);
	} else {
		$tmp4 = $tmp2;
	}

	$tmp4 ||= $ARGV[0];
	$in{'id'} = $tmp4;
	@Query = split(/\&/, $tmp4);
	foreach (@Query) {
		local($n,$v) = split(/=/, $_, 2);
		$v =~ tr/\+/ /;
		$n =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
		$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
		$v =~ s/&/&amp;/g;
		$v =~ s/</&lt;/g;
		$v =~ s/>/&gt;/g;
		$v =~ s/"/&quot;/g;
		$v =~ s// /g;
		$v =~ s/\t/ /g;
		$v =~ s/\r\n?/\n/g;
		if ($in{$n} && $n ne 'id') {
			$in{$n} .= "&$v";
		} else {
			$in{$n} = $v;
		}
	}
	undef @_;
}

sub error {

	%error = (
		'01.ERROR CODE' => $_[0],
		'02.PID' => $$,
		'03.UID' => $<,
		'04.EUID' => $>,
		'05.GID' => $(,
		'06.EGID' => $),
		'07.OS NAME' => $^O,
		'08.PROGRAM NAME' => $0,
		'09.PERL VERSION' => $],
		'10.DEBUGGING' => $^A,
		'11.BASETIME' => $^T,
		'12.EXEC NAME' => $^X,
	);

	$email{'error code'} = $error{'ERROR CODE'};
	$email{'url'} = $ENV{'HTTP_HOST'} . $ENV{'REQUEST_URI'};
	if ($ENV{'QUERY_STRING'}) { $email{'url'} .= '?' . $ENV{'QUERY_STRING'}; }

	$print .= '顼ȯޤ. ǤԤޤǤϢ.' . "\n<br>\n";
	$print .= '꤯.' . "\n<br>\n";
	$print .= '<table border=1 style="font-size:smaller">' . "\n";
	foreach (sort keys %error) {
		my ($tmp1) = $_;
		$tmp1 =~ s/^\d+\.//g;
		$print .= "<tr><th>$tmp1</th><td>$error{$_}</td></tr>\n";
		$email{'error'} .= sprintf("%-20s%-s\n",$tmp1,$error{$_});
	}
	foreach (sort keys %SET) {
		$email{'setting'} .= sprintf("%-20s%-s\n",$_,$SET{$_});
	}
	foreach (sort keys %in) {
		my ($tmp1);
		$tmp1 = uc ($_);
		$print .= "<tr><th>$tmp1</th><td>$in{$_}</td></tr>\n";
		$email{'query'} .= sprintf("%-20s%-s\n",$tmp1,$in{$_});
	}
	foreach (sort keys %ENV) {
		$email{'env'} .= sprintf("%-25s%-s\n",$_,$ENV{$_});
	}
	$print .= '</table>';

	&sendmail(&_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.email.error$browser","$SET{'USER_DIR'}/BF.email.error$browser"),\%email);

	$head = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.head$browser","$SET{'USER_DIR'}/BF.head$browser");
	$foot = &_open(undef,"$SET{'USER_DIR'}/$in{'id'}/BF.foot$browser","$SET{'USER_DIR'}/BF.foot$browser");
	&print;
	undef @_;
	exit;
}

sub print {
	$print = $head . $print . $foot;
	&_default;

	$print = &do($print);
	&_transpose($print);
	$print = &change($print);
	$print =~ s/<form (.*?)action=(["']?)($cgi|{cgi})\2(.*?)>(.*?)<\/form>/&_form/geis;

	&_replace(\$print,'THREAD',$thread);
	&_replace(\$print,'LOG',$log);
	&_replace(\$print,'DATE',$date);
	&_replace(\$print,'VERSION',$main::version);
	&_replace(\$print,'ADDRESS','<a href="mailto:' . $SET{'ADDRESS'} . '">' . $SET{'ADDRESS'} . '</a>');

	if ($code[1]) { &code(\$print,$code[1]); }

	foreach (keys %plugin) {
		$print = "<!-- Plugin: $_ ($plugin{$_}) -->\n" . $print;
	}
	$print = "<!-- Version: $main::revision -->\n" . $print;
	$print = "<!-- Admin: $SET{'ADDRESS'} -->\n" . $print;
	$print = "<!-- Time: " . (sprintf "%.2f", ((times)[0] - $time{'start'})) . " -->\n" . $print;

	select (STDOUT);

	print "Content-type: $content; charset=$code[0]\n";
	print "$header\n";

	$packed = pack("C*","36","112","114","105","110","116","32","61","126","32","115","47","60","116","105","116","108","101","40","46","42","63","41","62","40","46","42","63","41","60","92","47","116","105","116","108","101","62","47","60","116","105","116","108","101","36","49","62","66","46","70","111","114","117","109","32","58","32","36","50","32","45","32","36","109","97","105","110","58","58","118","101","114","115","105","111","110","40","82","101","118","105","115","105","111","110","58","36","109","97","105","110","58","58","114","101","118","105","115","105","111","110","41","60","92","47","116","105","116","108","101","62","47","105","59","112","114","105","110","116","32","36","112","114","105","110","116","59");
	eval ($packed);

	undef @_;
	exit;
}

1;
